/* script.h - simple animation engine */

#ifndef SCRIPT_H
#define SCRIPT_H

#include "list.h"
#include "im.h"

#define SCRIPT_MAX_PICS 50

/* script event */
typedef struct
{
  int p;         /* pic */
  int t;         /* time */
  int d;         /* duration */
  int x,y;       /* position */
  double a,u,v;  /* angle, scalex,scaley */
  int f;         /* foreground, background? */
} script_t;

/* function prototypes */
void script_init(void);
script_t *script_add(void);
script_t *script_get(void);
void script_remove(void);
void script_update(void);
script_t *script_rotate(void);
int script_advance(int);
int script_set_ticks(int);
void script_draw(im_t *);
void script_render(im_t *, uint8 *);
void script_load(char *);
void script_save(char *);

void buffer_add(im_t *, im_t *, double);
void buffer_mul(im_t *, double);
void buffer_crossfade(im_t *, im_t *, im_t *, double);
void buffer_invert(im_t *);
void buffer_clip(im_t *);

#endif
