/* xmalloc.c - error handling around the memory allocation functions */

#include <stdio.h>
#include <string.h>
#include "xmalloc.h"

static void *test (void *);


static void *
test(void *p)
{
  if (p == NULL)
    {
      fprintf(stderr, "out of memory\n");
      exit(1);
    }
  
  return p;
}

void *xmalloc(size_t s)           { return test(malloc(s)); }
void *xcalloc(size_t c, size_t s) { return test(calloc(c,s)); }
void *xrealloc(void *b, size_t s) { return test(realloc(b,s)); }
void xfree(void *p)               { if (p) { free(p); p = NULL; } }
char *xstrdup(const char *s) { return strcpy(xmalloc(strlen(s)+1),s); }
